(function() {
  var Animation, delay, jqueryify, release, removed;
  var __slice = Array.prototype.slice;

  Animation = require('animation').Animation;

  removed = function(el) {
    return el.closed === "removed";
  };

  delay = function(job) {
    var _ref;
    if (removed(this)) return;
    if (this._jquery != null) {
      return job();
    } else {
      if ((_ref = this._jquery_delay) == null) this._jquery_delay = [];
      return this._jquery_delay.push(job);
    }
  };

  release = function() {
    var job, _i, _len, _ref;
    if (this._jquery_delay != null) {
      _ref = this._jquery_delay;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        job = _ref[_i];
        job();
      }
      return delete this._jquery_delay;
    }
  };

  jqueryify = function(tpl) {
    var animation, old_query;
    animation = new Animation({
      timeoutexecution: '50ms',
      execution: '5ms',
      timeout: '100ms',
      toggle: true
    });
    animation.start();
    tpl.on('add', function(parent, el) {
      return delay.call(parent, function() {
        if (parent === tpl.xml) {
          return parent._jquery = parent._jquery.add(el._jquery);
        } else {
          return animation.push(function() {
            var _ref;
            return (_ref = parent._jquery) != null ? _ref.append(el._jquery) : void 0;
          });
        }
      });
    });
    tpl.on('close', function(el) {
      var _ref;
      if ((_ref = el._jquery) == null) el._jquery = $(el.toString());
      release.call(el);
      return el.on('newListener', function(type) {
        var _ref2, _ref3;
        if ((_ref2 = el._events) != null ? (_ref3 = _ref2[type]) != null ? _ref3.length : void 0 : void 0) {
          return;
        }
        return el._jquery.bind(type, function() {
          el.emit.apply(el, [type, this].concat(__slice.call(arguments)));
        });
      });
    });
    tpl.on('text', function(el, text) {
      return delay.call(el, function() {
        return el._jquery.text(text);
      });
    });
    tpl.on('raw', function(el, html) {
      return delay.call(el, function() {
        return animation.push(function() {
          var _ref;
          return (_ref = el._jquery) != null ? _ref.html(html) : void 0;
        });
      });
    });
    tpl.on('show', function(el) {
      return delay.call(el, function() {
        return el._jquery.show();
      });
    });
    tpl.on('hide', function(el) {
      return delay.call(el, function() {
        return el._jquery.hide();
      });
    });
    tpl.on('attr', function(el, key, value) {
      return delay.call(el, function() {
        return el._jquery.attr(key, value);
      });
    });
    tpl.on('attr:remove', function(el, key) {
      return delay.call(el, function() {
        return el._jquery.removeAttr(key);
      });
    });
    tpl.on('replace', function(el, tag) {
      return delay.call(el, function() {
        return animation.push(function() {
          var _jquery, _ref;
          if (removed(el)) return;
          _jquery = (_ref = tag._jquery) != null ? _ref : tag;
          if (!((_jquery != null ? _jquery.length : void 0) > 0)) return;
          el._jquery.replaceWith(_jquery);
          el._jquery = _jquery;
          if (el === tpl.xml) return el.jquery = _jquery;
        });
      });
    });
    tpl.on('remove', function(el) {
      return delay.call(el.parent, function() {
        var _ref;
        if ((_ref = el._jquery) != null) _ref.remove();
        return delete el._jquery;
      });
    });
    tpl.on('end', function() {
      tpl.xml._jquery = $();
      release.call(tpl.xml);
      return tpl.jquery = tpl.xml._jquery;
    });
    old_query = tpl.xml.query;
    tpl.xml.query = function(type, tag, key) {
      if (tag._jquery == null) return old_query.call(this, type, tag, key);
      if (type === 'attr') {
        return tag._jquery.attr(key);
      } else if (type === 'text') {
        return tag._jquery.text();
      } else if (type === 'tag') {
        if (key._jquery != null) {
          return key;
        } else {
          return {
            _jquery: key
          };
        }
      }
    };
    return tpl;
  };

  module.exports = jqueryify;

  if (process.title === 'browser') {
    (function() {
      if (this.dynamictemplate != null) {
        return this.dynamictemplate.jqueryify = jqueryify;
      } else {
        return this.dynamictemplate = {
          jqueryify: jqueryify
        };
      }
    }).call(window);
  }

}).call(this);
